/*
	MagaDebug32 fobOc[ Ver1.40
	wb_[t@C
	ib^b{{ʁj
*/
#if !defined(___MAGADBGCLASS_H)
#define	___MAGADBGCLASS_H

/*
	VisualC++  BolandC++ ɑΉ
*/
#if !defined(_MSC_VER) && !defined(__BORLANDC__)
#error This debug tool is much with VisualC++ and BorlandC++ only.
#endif
#if defined(__BORLANDC__) && defined(__MT__)
#define _MT
#endif

/*
	ސޯӰނɋ
	VC++ Only
	(Ver1.4x ȍ~ Releaseplib ɂĊɘa̗\)
*/
#if defined(_MSC_VER) && !defined(_DEBUG)
#error This condition requires that the RuntimeLibrary for debug version should be designated.
#endif

#include <windows.h>

/* MagaDbg ׽ (үނ󂯎۸) */
#if !defined(MAGADBGNAME)
#define MAGADBGNAME		 "MagaDbg"
#endif

/* հގgp׸ (C/C++p)*/
#define DBG_NOHEADERDUMP	0x0001	/* ͯް\ */
#define DBG_OCTDUMP			0x0002	/* 8޲ĂÂ */
#define DBG_NOADDRESSDUMP	0x0004	/* ڽ\ */
#define	DBG_NOCHRDUMP		0x0008	/* ׸\ */


#if defined(__cplusplus)

// Aliase of class name
#if defined(_MT)
	#if !defined(_DLL)
		#define CMagaDbg			CMagaDbg_MT
		#define CMagaDbgFile		CMagaDbgFile_MT
		#define g_MagaDbgMapNumber	g_MagaDbgMapNumber_MT
	#else
		#define CMagaDbg			CMagaDbg_MD
		#define CMagaDbgFile		CMagaDbgFile_MD
		#define g_MagaDbgMapNumber	g_MagaDbgMapNumber_MD
	#endif
#endif

// հގgp׸ (C++̂)
const	BOOL	CR = TRUE;		// \s
const	BOOL	CRNO = FALSE;	// \s
enum	dbgColor
		{DBG_BLACK = 0, DBG_BLUE, DBG_GREEN, DBG_CYAN,
		DBG_RED, DBG_MAGENTA, DBG_YELLOW, DBG_WHITE};
								// \F
//
// {fobONX錾
// ------------------------------
class CMagaDbg {

private:
	char*	m_lpszHead;		// M̓xɕt郁bZ[Wwb_
	int		m_iHeadLen;		// ̕
	BOOL	m_fSep;			// jƂɋ؂蕶邩
	int		m_iColor;		// \F(int^ŕێ)
	DWORD	m_nInterval;	// \̃C^[o

	COPYDATASTRUCT	m_cds;			// Mp\
	LONG			m_nMapNumber;	// DebugMessage MappingSeq No.
	HANDLE			m_hDbgMap;		// DebugMessage MemoryMappedFile Handle
	LPSTR			m_lpDbgMap;		// DebugMessage Mapping Pointer
private:
	void	CMagaDbgInit(char*, BOOL, dbgColor, DWORD = 0);

protected:
	void	SetHeader(char*, CMagaDbg*);
	int		AddHeader(char**, char*);
	HWND	MagaDbgFind(void) {
		return (FindWindow(MAGADBGNAME, NULL));
	}
	BOOL	GetSeparator(void) {
		return m_fSep;
	}
	DWORD	GetInterval(void) {
		return m_nInterval;
	}

public:
	CMagaDbg(void);
	CMagaDbg(char*, BOOL = FALSE, dbgColor = DBG_BLACK, DWORD = 0);
	CMagaDbg(char*, dbgColor);
	CMagaDbg(char*, BOOL);
	CMagaDbg(BOOL);
	CMagaDbg(dbgColor);
	CMagaDbg(BOOL, dbgColor);
	virtual	~CMagaDbg();

public:
	virtual	void print(char*,	BOOL = CR);		// 127ȓ̕\
	void	printf(char*, ...);					// 127ȓ̔Cӕ\
	void	printStruct(LPRECT, char* = NULL);	// 悭g\̃o̕\
	void	printStruct(LPSIZE, char* = NULL);
	void	printStruct(LPPOINT, char* = NULL);
	void	dump(LPVOID, UINT, DWORD = 0);		// _v\
	BOOL	scanf(char*, char* = NULL);			// Cӕ
	void	SetInterval(DWORD n) {
		m_nInterval = n;
	}
};

#define	printRect(LPRECT)		printStruct(LPRECT)
#define	printSize(LPSIZE)		printStruct(LPSIZE)
#define	printPoint(LPPOINT)		printStruct(LPPOINT)


// CMagaDbgFilep IvVݒ\
// ------------------------------
struct MAGADBGOPT {
	char*		lpszFilename;	// Ot@C
	BOOL		fOverwrite;		// ㏑:TRUECǉ:FALSE
	BOOL		fDisplay;		// \:TRUECt@Co͂̂:FALSE
	char*		lpHead;			// ȉ{ݽ׸Ɠ
	BOOL		fSeparator;
	dbgColor	eColor;
	DWORD		nInterval;
};
#define	LPMAGADBGOPT	MAGADBGOPT*

//
// hfobONX錾
// ------------------------------
class CMagaDbgFile : public CMagaDbg {

private:
	void	CMagaDbgFileInit(LPMAGADBGOPT);
	void	ErrorMsg(char*, DWORD);

private:
	HANDLE	m_hFile;		// LogFile Handle
	BOOL	m_fDisplay;		// \sǂ

public:
	CMagaDbgFile(LPMAGADBGOPT);
	CMagaDbgFile(char*, BOOL = TRUE, BOOL = TRUE, char* = NULL, BOOL = FALSE, dbgColor = DBG_BLACK, DWORD = 0);
	~CMagaDbgFile();

public:
	void print(char*,	BOOL = CR);	// ްײ
};

	// End of C++ only
#endif


#if defined(__cplusplus)
extern "C" {
#endif

// Aliase of function name
#if defined(_MT)
	#if !defined(_DLL)
		#define Dbg_printf	Dbg_printf_MT
		#define Dbg_sep		Dbg_sep_MT
		#define Dbg_scanf	Dbg_scanf_MT
		#define Dbg_dump	Dbg_dump_MT
	#else
		#define Dbg_printf	Dbg_printf_MD
		#define Dbg_sep		Dbg_sep_MD
		#define Dbg_scanf	Dbg_scanf_MD
		#define Dbg_dump	Dbg_dump_MD
	#endif
#endif

void Dbg_printf(char *, ...);
void Dbg_sep(void);
BOOL Dbg_scanf(char *, char *);
void Dbg_dump(void *, UINT, DWORD);

#if defined(__cplusplus)
}
#endif

#endif
